Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/include/Dcache_Access.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/include/Dcache_Access.h	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/include/Dcache_Access.h	(revision 88)
@@ -0,0 +1,174 @@
+#ifndef morpheo_behavioural_core_dcache_access_Dcache_Access_h
+#define morpheo_behavioural_core_dcache_access_Dcache_Access_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#ifdef SYSTEMC
+#include "systemc.h"
+#endif
+
+
+#include "Behavioural/Core/Dcache_Access/include/Parameters.h"
+#include "Behavioural/Core/Dcache_Access/include/Types.h"
+#ifdef STATISTICS
+#include "Behavioural/include/Stat.h"
+#endif
+#include "Behavioural/include/Component.h"
+#ifdef VHDL
+#include "Behavioural/include/Vhdl.h"
+#endif
+#include "Behavioural/include/Usage.h"
+
+#include "Common/include/ToString.h"
+#include "Common/include/Debug.h"
+
+#include "Behavioural/Generic/Priority/include/Priority.h"
+
+#include <iostream>
+
+namespace morpheo {
+namespace behavioural {
+
+namespace core {
+namespace dcache_access {
+
+
+  class Dcache_Access 
+#if SYSTEMC
+    : public sc_module
+#endif
+  {
+    // -----[ fields ]----------------------------------------------------
+    // Parameters
+  protected : const std::string  _name;
+  protected : const Parameters * _param;
+  private   : const Tusage_t     _usage;
+
+#ifdef STATISTICS
+  public    : Stat                           * _stat;
+
+  private   : counter_t                     ** _stat_nb_access;
+  private   : counter_t                     ** _stat_nb_access_conflit;
+#endif
+
+  public    : Component                      * _component;
+  private   : Interfaces                     * _interfaces;
+
+#ifdef SYSTEMC
+    // ~~~~~[ Interface ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    // ~~~~~[ Interface : "" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  public    : SC_CLOCK                      *  in_CLOCK        ;
+  public    : SC_IN (Tcontrol_t)            *  in_NRESET       ;
+
+    // ~~~~~[ Interface "dcache_req" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  public    : SC_OUT(Tcontrol_t           )   ** out_DCACHE_REQ_VAL         ;//[nb_dcache_port]
+  public    : SC_IN (Tcontrol_t           )   **  in_DCACHE_REQ_ACK         ;//[nb_dcache_port]
+  public    : SC_OUT(Tcontext_t           )   ** out_DCACHE_REQ_THREAD_ID   ;//[nb_dcache_port]
+  public    : SC_OUT(Tpacket_t            )   ** out_DCACHE_REQ_PACKET_ID   ;//[nb_dcache_port]
+  public    : SC_OUT(Tdcache_address_t    )   ** out_DCACHE_REQ_ADDRESS     ;//[nb_dcache_port]
+  public    : SC_OUT(Tdcache_data_t       )   ** out_DCACHE_REQ_WDATA       ;//[nb_dcache_port]
+  public    : SC_OUT(Tdcache_type_t       )   ** out_DCACHE_REQ_TYPE        ;//[nb_dcache_port]
+									    
+    // ~~~~~[ Interface "dcache_rsp" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  
+  public    : SC_IN (Tcontrol_t           )   **  in_DCACHE_RSP_VAL         ;//[nb_dcache_port]
+  public    : SC_OUT(Tcontrol_t           )   ** out_DCACHE_RSP_ACK         ;//[nb_dcache_port]
+  public    : SC_IN (Tcontext_t           )   **  in_DCACHE_RSP_THREAD_ID   ;//[nb_dcache_port]
+  public    : SC_IN (Tpacket_t            )   **  in_DCACHE_RSP_PACKET_ID   ;//[nb_dcache_port]
+  public    : SC_IN (Tdcache_data_t       )   **  in_DCACHE_RSP_RDATA       ;//[nb_dcache_port]
+  public    : SC_IN (Tdcache_error_t      )   **  in_DCACHE_RSP_ERROR       ;//[nb_dcache_port]
+
+    // ~~~~~[ Interface "lsq_req" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  public    : SC_IN (Tcontrol_t           ) ****  in_LSQ_REQ_VAL            ;//[nb_execute_loop][nb_load_store_unit][nb_cache_access]
+  public    : SC_OUT(Tcontrol_t           ) **** out_LSQ_REQ_ACK            ;//[nb_execute_loop][nb_load_store_unit][nb_cache_access]
+  public    : SC_IN (Tcontext_t           ) ****  in_LSQ_REQ_THREAD_ID      ;//[nb_execute_loop][nb_load_store_unit][nb_cache_access]
+  public    : SC_IN (Tpacket_t            ) ****  in_LSQ_REQ_PACKET_ID      ;//[nb_execute_loop][nb_load_store_unit][nb_cache_access]
+  public    : SC_IN (Tdcache_address_t    ) ****  in_LSQ_REQ_ADDRESS        ;//[nb_execute_loop][nb_load_store_unit][nb_cache_access]
+  public    : SC_IN (Tdcache_data_t       ) ****  in_LSQ_REQ_WDATA          ;//[nb_execute_loop][nb_load_store_unit][nb_cache_access]
+  public    : SC_IN (Tdcache_type_t       ) ****  in_LSQ_REQ_TYPE           ;//[nb_execute_loop][nb_load_store_unit][nb_cache_access]
+
+    // ~~~~~[ Interface "lsq_rsp" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  public    : SC_OUT(Tcontrol_t           ) **** out_LSQ_RSP_VAL            ;//[nb_execute_loop][nb_load_store_unit][nb_cache_access]
+  public    : SC_IN (Tcontrol_t           ) ****  in_LSQ_RSP_ACK            ;//[nb_execute_loop][nb_load_store_unit][nb_cache_access]
+  public    : SC_OUT(Tcontext_t           ) **** out_LSQ_RSP_THREAD_ID      ;//[nb_execute_loop][nb_load_store_unit][nb_cache_access]
+  public    : SC_OUT(Tpacket_t            ) **** out_LSQ_RSP_PACKET_ID      ;//[nb_execute_loop][nb_load_store_unit][nb_cache_access]
+  public    : SC_OUT(Tdcache_data_t       ) **** out_LSQ_RSP_RDATA          ;//[nb_execute_loop][nb_load_store_unit][nb_cache_access]
+  public    : SC_OUT(Tdcache_error_t      ) **** out_LSQ_RSP_ERROR          ;//[nb_execute_loop][nb_load_store_unit][nb_cache_access]
+
+    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+  private   : generic::priority::Priority      * _priority;
+
+    // ~~~~~[ Register ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+
+    // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+#ifdef STATISTICS
+  private   : uint32_t                         * _internal_DCACHE_REQ_NB_ACCESS        ; //[nb_dcache_port]
+  private   : uint32_t                         * _internal_DCACHE_REQ_NB_ACCESS_CONFLIT; //[nb_dcache_port]
+#endif
+
+#endif
+
+    // -----[ Methods ]---------------------------------------------------
+
+#ifdef SYSTEMC
+    SC_HAS_PROCESS (Dcache_Access);
+#endif
+  public  :          Dcache_Access              
+  (
+#ifdef SYSTEMC
+   sc_module_name                                name,
+#else					       
+   std::string                                   name,
+#endif					       
+#ifdef STATISTICS
+   morpheo::behavioural::Parameters_Statistics * param_statistics,
+#endif
+   Parameters                                  * param,
+   morpheo::behavioural::Tusage_t                usage
+   );
+  public  :          ~Dcache_Access             (void);
+					       
+  private : void        allocation                (
+#ifdef STATISTICS
+						   morpheo::behavioural::Parameters_Statistics * param_statistics
+#else
+						   void
+#endif
+						   );
+  private : void        deallocation              (void);
+					       
+#ifdef SYSTEMC				       
+  public  : void        transition                (void);
+//public  : void        genMoore                  (void);
+  public  : void        genMealy_req              (void);
+  public  : void        genMealy_rsp              (void);
+
+#endif					       
+
+#if VHDL				       
+  public  : void        vhdl                      (void);
+  private : void        vhdl_declaration          (Vhdl * & vhdl);
+  private : void        vhdl_body                 (Vhdl * & vhdl);
+#endif					       
+
+#ifdef STATISTICS
+  public  : void        statistics_allocation     (morpheo::behavioural::Parameters_Statistics * param_statistics);
+  public  : void        statistics_deallocation   (void);
+#endif
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+  private : void        end_cycle                 (void);
+#endif
+  };
+
+}; // end namespace dcache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/include/Parameters.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/include/Parameters.h	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/include/Parameters.h	(revision 88)
@@ -0,0 +1,92 @@
+#ifndef morpheo_behavioural_core_dcache_access_Parameters_h
+#define morpheo_behavioural_core_dcache_access_Parameters_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Dcache_Access/include/Types.h"
+#include "Behavioural/include/Parameters.h"
+#include "Common/include/Debug.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace dcache_access {
+
+
+  class Parameters : public morpheo::behavioural::Parameters
+  {
+    //-----[ fields ]------------------------------------------------------------
+  public : uint32_t             _nb_thread              ;
+  public : uint32_t             _nb_execute_loop        ;
+  public : uint32_t           * _nb_load_store_unit     ;//[nb_execute_loop]
+  public : uint32_t           * _nb_context             ;//[nb_execute_loop]//{nb_front_end + nb_context}
+  public : uint32_t          ** _nb_cache_access        ;//[nb_execute_loop][nb_load_store_unit]
+  public : uint32_t             _nb_dcache_port         ;
+  public : uint32_t             _size_address           ;
+  public : uint32_t             _size_data              ;
+  public : uint32_t             _size_dcache_thread_id  ;
+  public : uint32_t             _size_dcache_packet_id  ;
+  public : uint32_t          ** _size_thread_id         ;//[nb_execute_loop][nb_load_store_unit]
+  public : uint32_t          ** _size_packet_id         ;//[nb_execute_loop][nb_load_store_unit]
+  public : uint32_t         *** _table_routing          ;//[nb_execute_loop][nb_load_store_unit][nb_cache_access]
+  public : Tpriority_t          _priority               ;
+  public : Tload_balancing_t    _load_balancing         ;
+  public : uint32_t         *** _translate_load_store_unit_to_thread; //[nb_execute_loop][nb_load_store_unit][nb_context]
+
+  public : uint32_t             _max_nb_load_store_unit   ;
+  public : uint32_t             _max_nb_cache_access      ;
+  public : Tcontext_t           _shift_num_cache_access   ;
+  public : Tcontext_t           _mask_num_cache_access    ;
+  public : Tcontext_t           _mask_num_lsq_packet      ;
+  public : uint32_t           * _translate_thread_to_execute_loop   ; //[nb_thread]
+  public : uint32_t           * _translate_thread_to_load_store_unit; //[nb_thread]
+  public : uint32_t           * _translate_thread_to_context        ; //[nb_thread]
+    
+  public : bool              ** _have_port_lsq_thread_id   ;//[nb_execute_loop][nb_load_store_unit]
+  public : bool              ** _have_port_lsq_packet_id   ;//[nb_execute_loop][nb_load_store_unit]
+  public : bool                 _have_port_dcache_thread_id;
+  public : bool                 _have_port_dcache_packet_id;
+    
+    //-----[ methods ]-----------------------------------------------------------
+  public : Parameters  (uint32_t             nb_thread              ,
+                        uint32_t             nb_execute_loop        ,
+			uint32_t           * nb_load_store_unit     ,
+			uint32_t           * nb_context             ,
+			uint32_t          ** nb_cache_access        ,
+			uint32_t             nb_dcache_port         ,
+			uint32_t             size_address           ,
+			uint32_t             size_data              ,
+                        uint32_t             size_dcache_thread_id  ,
+                        uint32_t             size_dcache_packet_id  ,
+			uint32_t          ** size_thread_id         ,
+			uint32_t          ** size_packet_id         ,
+			uint32_t         *** table_routing          ,
+			Tpriority_t          priority               ,
+			Tload_balancing_t    load_balancing         ,
+                        uint32_t         *** translate_load_store_unit_to_thread,
+                        bool                 is_toplevel=false      );
+
+//   public : Parameters  (Parameters & param) ;
+  public : ~Parameters () ;
+
+  public :        void            copy       (void);
+
+  public :        Parameters_test msg_error  (void);
+
+  public :        std::string     print      (uint32_t depth);
+  public : friend std::ostream&   operator<< (std::ostream& output_stream,
+					    morpheo::behavioural::core::dcache_access::Parameters & x);
+  };
+
+}; // end namespace dcache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/include/Types.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/include/Types.h	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/include/Types.h	(revision 88)
@@ -0,0 +1,25 @@
+#ifndef morpheo_behavioural_core_dcache_access_Types_h
+#define morpheo_behavioural_core_dcache_access_Types_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Types.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace dcache_access {
+
+
+}; // end namespace dcache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access.cpp	(revision 88)
@@ -0,0 +1,178 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Dcache_Access/include/Dcache_Access.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace dcache_access {
+
+
+#undef  FUNCTION
+#define FUNCTION "Dcache_Access::Dcache_Access"
+  Dcache_Access::Dcache_Access 
+  (
+#ifdef SYSTEMC
+   sc_module_name name,
+#else
+   string name,
+#endif
+#ifdef STATISTICS
+   morpheo::behavioural::Parameters_Statistics * param_statistics,
+#endif
+   morpheo::behavioural::core::dcache_access::Parameters * param,
+   morpheo::behavioural::Tusage_t usage
+   ):
+    _name              (name)
+    ,_param            (param)
+    ,_usage            (usage)
+  {
+    log_begin(Dcache_Access,FUNCTION);
+
+    usage_environment(_usage);
+
+#if DEBUG_Dcache_Access == true
+    log_printf(INFO,Dcache_Access,FUNCTION,_("<%s> Parameters"),_name.c_str());
+
+    std::cout << *param << std::endl;
+#endif    
+
+    log_printf(INFO,Dcache_Access,FUNCTION,_("<%s> : Allocation"),_name.c_str());
+
+    allocation (
+#ifdef STATISTICS
+		param_statistics
+#endif
+		);
+
+#ifdef STATISTICS
+    if (usage_is_set(_usage,USE_STATISTICS))
+      {	
+	log_printf(INFO,Dcache_Access,FUNCTION,_("<%s> : Allocation of statistics"),_name.c_str());
+
+	statistics_allocation(param_statistics);
+      }
+#endif
+
+#ifdef VHDL
+    if (usage_is_set(_usage,USE_VHDL))
+      {
+	// generate the vhdl
+	log_printf(INFO,Dcache_Access,FUNCTION,_("<%s> : Generate the vhdl"),_name.c_str());
+	
+	vhdl();
+      }
+#endif
+
+#ifdef SYSTEMC
+    if (usage_is_set(_usage,USE_SYSTEMC))
+      {
+	log_printf(INFO,Dcache_Access,FUNCTION,_("<%s> : Method - transition"),_name.c_str());
+
+	SC_METHOD (transition);
+	dont_initialize ();
+	sensitive << (*(in_CLOCK)).pos();
+	
+# ifdef SYSTEMCASS_SPECIFIC
+	// List dependency information
+# endif    
+
+// 	log_printf(INFO,Dcache_Access,FUNCTION,_("<%s> : Method - genMoore"),_name.c_str());
+
+// 	SC_METHOD (genMoore);
+// 	dont_initialize ();
+// 	sensitive << (*(in_CLOCK)).neg(); // need internal register
+	
+// # ifdef SYSTEMCASS_SPECIFIC
+// 	// List dependency information
+// # endif    
+
+	log_printf(INFO,Dcache_Access,FUNCTION,_("<%s> : Method - genMealy_req"),_name.c_str());
+
+	SC_METHOD (genMealy_req);
+	dont_initialize ();
+	sensitive << (*(in_CLOCK)).neg(); // need internal register
+	for (uint32_t i=0; i<_param->_nb_dcache_port; ++i)
+	  sensitive << (*(in_DCACHE_REQ_ACK [i]));
+	for (uint32_t i=0; i<_param->_nb_execute_loop; ++i)
+	  for (uint32_t j=0; j<_param->_nb_load_store_unit[i]; ++j)
+	    for (uint32_t k=0; k<_param->_nb_cache_access [i][j]; ++k)
+	      {
+		sensitive << (*(in_LSQ_REQ_VAL       [i][j][k]))
+			  << (*(in_LSQ_REQ_ADDRESS   [i][j][k]))
+			  << (*(in_LSQ_REQ_WDATA     [i][j][k]))
+			  << (*(in_LSQ_REQ_TYPE      [i][j][k]));
+		
+		if (_param->_have_port_lsq_thread_id [i][j])
+		  sensitive << (*(in_LSQ_REQ_THREAD_ID [i][j][k]));
+		if (_param->_have_port_lsq_packet_id [i][j])
+		sensitive << (*(in_LSQ_REQ_PACKET_ID [i][j][k]));
+	      }
+
+
+# ifdef SYSTEMCASS_SPECIFIC
+	// List dependency information
+# endif    
+
+	log_printf(INFO,Dcache_Access,FUNCTION,_("<%s> : Method - genMealy_rsp"),_name.c_str());
+
+	SC_METHOD (genMealy_rsp);
+	dont_initialize ();
+	sensitive << (*(in_CLOCK)).neg(); // need internal register
+
+	for (uint32_t i=0; i<_param->_nb_dcache_port; ++i)
+	  {
+	    sensitive << (*(in_DCACHE_RSP_VAL       [i]))
+		      << (*(in_DCACHE_RSP_RDATA     [i]))
+		      << (*(in_DCACHE_RSP_ERROR     [i]));
+	    if (_param->_have_port_dcache_thread_id)
+	    sensitive << (*(in_DCACHE_RSP_THREAD_ID [i]));
+	    if (_param->_have_port_dcache_packet_id)
+	    sensitive << (*(in_DCACHE_RSP_PACKET_ID [i]));
+
+	  }
+	for (uint32_t i=0; i<_param->_nb_execute_loop; ++i)
+	  for (uint32_t j=0; j<_param->_nb_load_store_unit[i]; ++j)
+	    for (uint32_t k=0; k<_param->_nb_cache_access [i][j]; ++k)
+	      sensitive << (*(in_LSQ_RSP_ACK [i][j][k]));
+
+
+
+# ifdef SYSTEMCASS_SPECIFIC
+	// List dependency information
+# endif    
+
+#endif
+      }
+    log_end(Dcache_Access,FUNCTION);
+  };
+    
+#undef  FUNCTION
+#define FUNCTION "Dcache_Access::~Dcache_Access"
+  Dcache_Access::~Dcache_Access (void)
+  {
+    log_begin(Dcache_Access,FUNCTION);
+
+#ifdef STATISTICS
+    if (usage_is_set(_usage,USE_STATISTICS))
+      {
+	statistics_deallocation();
+      }
+#endif
+
+    log_printf(INFO,Dcache_Access,FUNCTION,_("<%s> : Deallocation"),_name.c_str());
+    deallocation ();
+
+    log_end(Dcache_Access,FUNCTION);
+  };
+
+}; // end namespace dcache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_allocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_allocation.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_allocation.cpp	(revision 88)
@@ -0,0 +1,135 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Dcache_Access/include/Dcache_Access.h"
+#include "Behavioural/include/Allocation.h"
+#include "Common/include/Max.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace dcache_access {
+
+
+
+#undef  FUNCTION
+#define FUNCTION "Dcache_Access::allocation"
+  void Dcache_Access::allocation (
+#ifdef STATISTICS
+			       morpheo::behavioural::Parameters_Statistics * param_statistics
+#else
+			       void
+#endif
+			       )
+  {
+    log_begin(Dcache_Access,FUNCTION);
+
+    _component   = new Component (_usage);
+
+    Entity * entity = _component->set_entity (_name       
+					      ,"Dcache_Access"
+#ifdef POSITION
+					      ,COMBINATORY 
+#endif
+					      );
+
+    _interfaces = entity->set_interfaces();
+
+    // ~~~~~[ Interface : "" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    {
+      Interface * interface = _interfaces->set_interface(""
+#ifdef POSITION
+							 ,IN
+							 ,SOUTH,
+							 _("Generalist interface")
+#endif
+							 );
+      
+      in_CLOCK        = interface->set_signal_clk              ("clock" ,1, CLOCK_VHDL_YES);
+      in_NRESET       = interface->set_signal_in  <Tcontrol_t> ("nreset",1, RESET_VHDL_YES);
+    }
+
+    // ~~~~~[ Interface "dcache_req" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    {
+      ALLOC1_INTERFACE("dcache_req", OUT, NORTH, _("Request to data cache"),_param->_nb_dcache_port);
+      
+      ALLOC1_VALACK_OUT(out_DCACHE_REQ_VAL         ,VAL);
+      ALLOC1_VALACK_IN ( in_DCACHE_REQ_ACK         ,ACK);
+      ALLOC1_SIGNAL_OUT(out_DCACHE_REQ_THREAD_ID   ,"thread_id",Tcontext_t           ,_param->_size_dcache_thread_id);
+      ALLOC1_SIGNAL_OUT(out_DCACHE_REQ_PACKET_ID   ,"packet_id",Tpacket_t            ,_param->_size_dcache_packet_id);
+      ALLOC1_SIGNAL_OUT(out_DCACHE_REQ_ADDRESS     ,"address"  ,Tdcache_address_t    ,_param->_size_address);
+      ALLOC1_SIGNAL_OUT(out_DCACHE_REQ_WDATA       ,"wdata"    ,Tdcache_data_t       ,_param->_size_data);
+      ALLOC1_SIGNAL_OUT(out_DCACHE_REQ_TYPE        ,"type"     ,Tdcache_type_t       ,_param->_size_dcache_type);
+    }
+									    
+    // ~~~~~[ Interface "dcache_rsp" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  
+    {
+      ALLOC1_INTERFACE("dcache_rsp", IN , NORTH, _("Respons from data cache"),_param->_nb_dcache_port);
+
+      ALLOC1_VALACK_IN ( in_DCACHE_RSP_VAL         ,VAL);
+      ALLOC1_VALACK_OUT(out_DCACHE_RSP_ACK         ,ACK);
+      ALLOC1_SIGNAL_IN ( in_DCACHE_RSP_THREAD_ID   ,"thread_id",Tcontext_t           ,_param->_size_dcache_thread_id);
+      ALLOC1_SIGNAL_IN ( in_DCACHE_RSP_PACKET_ID   ,"packet_id",Tpacket_t            ,_param->_size_dcache_packet_id);
+      ALLOC1_SIGNAL_IN ( in_DCACHE_RSP_RDATA       ,"rdata"    ,Tdcache_data_t       ,_param->_size_data);
+      ALLOC1_SIGNAL_IN ( in_DCACHE_RSP_ERROR       ,"error"    ,Tdcache_error_t      ,_param->_size_dcache_error);
+    }
+
+    // ~~~~~[ Interface "lsq_req" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    {
+      ALLOC3_INTERFACE("lsq_req", IN, SOUTH, _("Request from load_store queue"), _param->_nb_execute_loop, _param->_nb_load_store_unit[it1], _param->_nb_cache_access[it1][it2]);
+
+      _ALLOC3_VALACK_IN ( in_LSQ_REQ_VAL            ,VAL, _param->_nb_execute_loop, _param->_nb_load_store_unit[it1], _param->_nb_cache_access[it1][it2]);
+      _ALLOC3_VALACK_OUT(out_LSQ_REQ_ACK            ,ACK, _param->_nb_execute_loop, _param->_nb_load_store_unit[it1], _param->_nb_cache_access[it1][it2]);
+      _ALLOC3_SIGNAL_IN ( in_LSQ_REQ_THREAD_ID      ,"thread_id",Tcontext_t           ,_param->_size_thread_id [it1][it2], _param->_nb_execute_loop, _param->_nb_load_store_unit[it1], _param->_nb_cache_access[it1][it2]);
+      _ALLOC3_SIGNAL_IN ( in_LSQ_REQ_PACKET_ID      ,"packet_id",Tpacket_t            ,_param->_size_packet_id [it1][it2], _param->_nb_execute_loop, _param->_nb_load_store_unit[it1], _param->_nb_cache_access[it1][it2]);
+      _ALLOC3_SIGNAL_IN ( in_LSQ_REQ_ADDRESS        ,"address"  ,Tdcache_address_t    ,_param->_size_address             , _param->_nb_execute_loop, _param->_nb_load_store_unit[it1], _param->_nb_cache_access[it1][it2]);
+      _ALLOC3_SIGNAL_IN ( in_LSQ_REQ_WDATA          ,"wdata"    ,Tdcache_data_t       ,_param->_size_data                , _param->_nb_execute_loop, _param->_nb_load_store_unit[it1], _param->_nb_cache_access[it1][it2]);
+      _ALLOC3_SIGNAL_IN ( in_LSQ_REQ_TYPE           ,"type"     ,Tdcache_type_t       ,_param->_size_dcache_type         , _param->_nb_execute_loop, _param->_nb_load_store_unit[it1], _param->_nb_cache_access[it1][it2]);
+    }
+
+    // ~~~~~[ Interface "lsq_rsp" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    {
+      ALLOC3_INTERFACE("lsq_rsp",OUT, SOUTH, _("Respons to load_store queue"), _param->_nb_execute_loop, _param->_nb_load_store_unit[it1], _param->_nb_cache_access[it1][it2]);
+      
+      _ALLOC3_VALACK_OUT(out_LSQ_RSP_VAL            ,VAL, _param->_nb_execute_loop, _param->_nb_load_store_unit[it1], _param->_nb_cache_access[it1][it2]);
+      _ALLOC3_VALACK_IN ( in_LSQ_RSP_ACK            ,ACK, _param->_nb_execute_loop, _param->_nb_load_store_unit[it1], _param->_nb_cache_access[it1][it2]);
+      _ALLOC3_SIGNAL_OUT(out_LSQ_RSP_THREAD_ID      ,"thread_id",Tcontext_t           ,_param->_size_thread_id [it1][it2], _param->_nb_execute_loop, _param->_nb_load_store_unit[it1], _param->_nb_cache_access[it1][it2]);
+      _ALLOC3_SIGNAL_OUT(out_LSQ_RSP_PACKET_ID      ,"packet_id",Tpacket_t            ,_param->_size_packet_id [it1][it2], _param->_nb_execute_loop, _param->_nb_load_store_unit[it1], _param->_nb_cache_access[it1][it2]);
+      _ALLOC3_SIGNAL_OUT(out_LSQ_RSP_RDATA          ,"rdata"    ,Tdcache_data_t       ,_param->_size_data                , _param->_nb_execute_loop, _param->_nb_load_store_unit[it1], _param->_nb_cache_access[it1][it2]);
+      _ALLOC3_SIGNAL_OUT(out_LSQ_RSP_ERROR          ,"error"    ,Tdcache_error_t      ,_param->_size_dcache_error       , _param->_nb_execute_loop, _param->_nb_load_store_unit[it1], _param->_nb_cache_access[it1][it2]);
+    }
+
+    // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#ifdef STATISTICS
+    if (usage_is_set(_usage,USE_SYSTEMC))
+      {
+        _internal_DCACHE_REQ_NB_ACCESS         = new uint32_t [_param->_nb_dcache_port];
+        _internal_DCACHE_REQ_NB_ACCESS_CONFLIT = new uint32_t [_param->_nb_dcache_port];
+      }
+#endif
+
+    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+    _priority  = new generic::priority::Priority (_name+"_priority",
+						  _param->_priority          ,
+						  _param->_load_balancing    ,
+						  _param->_nb_execute_loop   ,
+						  _param->_nb_load_store_unit,
+						  _param->_nb_execute_loop   );
+
+#ifdef POSITION
+    if (usage_is_set(_usage,USE_POSITION))
+	_component->generate_file();
+#endif
+
+    log_end(Dcache_Access,FUNCTION);
+  };
+
+}; // end namespace dcache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_deallocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_deallocation.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_deallocation.cpp	(revision 88)
@@ -0,0 +1,77 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Dcache_Access/include/Dcache_Access.h"
+#include "Behavioural/include/Allocation.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace dcache_access {
+
+
+#undef  FUNCTION
+#define FUNCTION "Dcache_Access::deallocation"
+  void Dcache_Access::deallocation (void)
+  {
+    log_begin(Dcache_Access,FUNCTION);
+
+    if (usage_is_set(_usage,USE_SYSTEMC))
+      {
+	delete    in_CLOCK ;
+	delete    in_NRESET;
+	
+        DELETE1_SIGNAL(out_DCACHE_REQ_VAL         ,_param->_nb_dcache_port,1);
+        DELETE1_SIGNAL( in_DCACHE_REQ_ACK         ,_param->_nb_dcache_port,1);
+        DELETE1_SIGNAL(out_DCACHE_REQ_THREAD_ID   ,_param->_nb_dcache_port,_param->_size_dcache_thread_id);
+        DELETE1_SIGNAL(out_DCACHE_REQ_PACKET_ID   ,_param->_nb_dcache_port,_param->_size_dcache_packet_id);
+        DELETE1_SIGNAL(out_DCACHE_REQ_ADDRESS     ,_param->_nb_dcache_port,_param->_size_address);
+        DELETE1_SIGNAL(out_DCACHE_REQ_WDATA       ,_param->_nb_dcache_port,_param->_size_data);
+        DELETE1_SIGNAL(out_DCACHE_REQ_TYPE        ,_param->_nb_dcache_port,_param->_size_dcache_type);
+
+        DELETE1_SIGNAL( in_DCACHE_RSP_VAL         ,_param->_nb_dcache_port,1);
+        DELETE1_SIGNAL(out_DCACHE_RSP_ACK         ,_param->_nb_dcache_port,1);
+        DELETE1_SIGNAL( in_DCACHE_RSP_THREAD_ID   ,_param->_nb_dcache_port,_param->_size_dcache_thread_id);
+        DELETE1_SIGNAL( in_DCACHE_RSP_PACKET_ID   ,_param->_nb_dcache_port,_param->_size_dcache_packet_id);
+        DELETE1_SIGNAL( in_DCACHE_RSP_RDATA       ,_param->_nb_dcache_port,_param->_size_data);
+        DELETE1_SIGNAL( in_DCACHE_RSP_ERROR       ,_param->_nb_dcache_port,_param->_size_dcache_error);
+
+        DELETE3_SIGNAL( in_LSQ_REQ_VAL            ,_param->_nb_execute_loop, _param->_nb_load_store_unit[it1], _param->_nb_cache_access[it1][it2],1);
+        DELETE3_SIGNAL(out_LSQ_REQ_ACK            ,_param->_nb_execute_loop, _param->_nb_load_store_unit[it1], _param->_nb_cache_access[it1][it2],1);
+        DELETE3_SIGNAL( in_LSQ_REQ_THREAD_ID      ,_param->_nb_execute_loop, _param->_nb_load_store_unit[it1], _param->_nb_cache_access[it1][it2],_param->_size_thread_id [it1][it2]);
+        DELETE3_SIGNAL( in_LSQ_REQ_PACKET_ID      ,_param->_nb_execute_loop, _param->_nb_load_store_unit[it1], _param->_nb_cache_access[it1][it2],_param->_size_packet_id [it1][it2]);
+        DELETE3_SIGNAL( in_LSQ_REQ_ADDRESS        ,_param->_nb_execute_loop, _param->_nb_load_store_unit[it1], _param->_nb_cache_access[it1][it2],_param->_size_address             );
+        DELETE3_SIGNAL( in_LSQ_REQ_WDATA          ,_param->_nb_execute_loop, _param->_nb_load_store_unit[it1], _param->_nb_cache_access[it1][it2],_param->_size_data                );
+        DELETE3_SIGNAL( in_LSQ_REQ_TYPE           ,_param->_nb_execute_loop, _param->_nb_load_store_unit[it1], _param->_nb_cache_access[it1][it2],_param->_size_dcache_type         );
+
+        DELETE3_SIGNAL(out_LSQ_RSP_VAL            ,_param->_nb_execute_loop, _param->_nb_load_store_unit[it1], _param->_nb_cache_access[it1][it2],1);
+        DELETE3_SIGNAL( in_LSQ_RSP_ACK            ,_param->_nb_execute_loop, _param->_nb_load_store_unit[it1], _param->_nb_cache_access[it1][it2],1);
+        DELETE3_SIGNAL(out_LSQ_RSP_THREAD_ID      ,_param->_nb_execute_loop, _param->_nb_load_store_unit[it1], _param->_nb_cache_access[it1][it2],_param->_size_thread_id [it1][it2]);
+        DELETE3_SIGNAL(out_LSQ_RSP_PACKET_ID      ,_param->_nb_execute_loop, _param->_nb_load_store_unit[it1], _param->_nb_cache_access[it1][it2],_param->_size_packet_id [it1][it2]);
+        DELETE3_SIGNAL(out_LSQ_RSP_RDATA          ,_param->_nb_execute_loop, _param->_nb_load_store_unit[it1], _param->_nb_cache_access[it1][it2],_param->_size_data                );
+        DELETE3_SIGNAL(out_LSQ_RSP_ERROR          ,_param->_nb_execute_loop, _param->_nb_load_store_unit[it1], _param->_nb_cache_access[it1][it2],_param->_size_dcache_error        );
+
+        // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#ifdef STATISTICS
+        delete [] _internal_DCACHE_REQ_NB_ACCESS        ;
+        delete [] _internal_DCACHE_REQ_NB_ACCESS_CONFLIT;
+#endif
+      }
+
+    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+    delete _priority;
+
+    delete _component;
+
+    log_end(Dcache_Access,FUNCTION);
+  };
+
+}; // end namespace dcache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
